<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Counter</title>
</head>

<body>
</body>
<script>
  class Button {
    constructor(props) {
      this.props = props
    }

    render() {
      if (this.view) {
        return this.view
      }

      const btn = document.createElement("button");
      btn.textContent = this.props.title;
      btn.onclick = this.props.onclick;
      this.view = btn
      return this.view;
    }
  }

  class Text {
    constructor(props) {
      this.props = props
    }

    render() {
      if (this.view) {
        this.view.textContent = this.props.content
        return this.view
      }

      const span = document.createElement("span")
      span.textContent = this.props.content
      this.view = span
      return this.view
    }
  }

  class Counter {
    constructor() {
      this.state = 0;
    }

    get counter() {
      return this.state
    }

    set counter(num) {
      this.state = num
      this.num.props.content = num
      this.num.render()
    }

    incement() {
      this.counter += 1;
    }

    decrement() {
      this.counter -= 1;
    }

    render() {
      if (this.view) {
        return this.view;
      }

      const container = document.createElement("div");

      const inc = new Button({
        title: "+",
        onclick: this.incement.bind(this),
      });
      container.appendChild(inc.render());

      const num = new Text({ content: this.counter });
      container.appendChild(num.render());
      this.num = num;

      const dec = new Button({
        title: "-",
        onclick: this.decrement.bind(this),
      });
      container.appendChild(dec.render());

      this.view = container;
      return this.view;
    }
  }

  class Root {
    constructor(props) {
      this.props = props;
    }

    render() {
      if (this.view) return this.view;

      const view = document.createElement("div")

      const list = document.createElement("div")
      view.appendChild(list);

      const Child = this.props.childTemplate;
      const more = document.createElement("button")
      more.textContent = "More"
      more.onclick = function () {
        const child = new Child();
        list.appendChild(child.render());
      }
      view.appendChild(more);

      this.view = view
      return this.view
    }
  }

  document.body.appendChild((new Root({ childTemplate: Counter })).render());
</script>

</html>